package com.zcloud.controller.majordangersource;

import com.zcloud.controller.base.BaseController;
import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.logs.LogAnno;
import com.zcloud.service.majordangersource.MajordangersourceStoragetankService;
import com.zcloud.util.DateUtil;
import com.zcloud.util.Jurisdiction;
import com.zcloud.util.ObjectExcelView;
import com.zcloud.util.Tools;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * 说明：重大危险源储罐数据
 * 作者：luoxiaobao
 * 时间：2022-04-22
 * 官网：www.zcloudchina.com
 */
@Controller
@RequestMapping("/storagetank")
public class MajordangersourceStoragetankController extends BaseController {

	@Autowired
	private MajordangersourceStoragetankService majordangersourcestoragetankService;

	/**新增
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/add")
	// @RequiresPermissions("majordangersourcestoragetank:add")
	@ResponseBody
	public Object add() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("MAJORDANGERSOURCESTORAGETANK_ID", this.get32UUID());	//主键
		majordangersourcestoragetankService.save(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/delete")
	// @RequiresPermissions("majordangersourcestoragetank:del")
	@ResponseBody
	public Object delete() throws Exception{
		Map<String,String> map = new HashMap<String,String>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		majordangersourcestoragetankService.delete(pd);
		map.put("result", errInfo);				//返回结果
		return map;
	}

	/**修改
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/edit")
	// @RequiresPermissions("majordangersourcestoragetank:edit")
	@ResponseBody
	public Object edit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		majordangersourcestoragetankService.edit(pd);
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	@RequestMapping(value="/list")
	// @RequiresPermissions("majordangersourcestoragetank:list")
	@ResponseBody
	public Object list(Page page) throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		String KEYWORDS = pd.getString("KEYWORDS");						//关键词检索条件
		if(Tools.notEmpty(KEYWORDS))pd.put("KEYWORDS", KEYWORDS.trim());
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		page.setPd(pd);
		List<PageData>	varList = majordangersourcestoragetankService.list(page);	//列出MajordangersourceStoragetank列表
		map.put("varList", varList);
		map.put("page", page);
		map.put("result", errInfo);
		return map;
	}

	 /**去修改页面获取数据
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/goEdit")
	@ResponseBody
	@LogAnno(menuType= "监测预警",menuServer= "重大危险源监测预警",instructionsOperate = "实时数据监测",instructionsType = "去修改页面获取数据")
	public Object goEdit() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd = majordangersourcestoragetankService.findById(pd);	//根据ID读取
		map.put("pd", pd);
		map.put("result", errInfo);
		return map;
	}

	 /**批量删除
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/deleteAll")
	// @RequiresPermissions("majordangersourcestoragetank:del")
	@ResponseBody
	public Object deleteAll() throws Exception{
		Map<String,Object> map = new HashMap<String,Object>();
		String errInfo = "success";
		PageData pd = new PageData();
		pd = this.getPageData();
		pd.put("OPERATOR", Jurisdiction.getUsername());	//修改人
		pd.put("OPERATTIME", DateUtil.date2Str(new Date()));	//修改时间
		String DATA_IDS = pd.getString("DATA_IDS");
		if(Tools.notEmpty(DATA_IDS)){
			String[] ArrayDATA_IDS = DATA_IDS.split(",");
			pd.put("ArrayDATA_IDS", ArrayDATA_IDS);	//待删除ids
			majordangersourcestoragetankService.deleteAll(pd);
			errInfo = "success";
		}else{
			errInfo = "error";
		}
		map.put("result", errInfo);				//返回结果
		return map;
	}

	 /**导出到excel
	 * @param
	 * @throws Exception
	 */
	@RequestMapping(value="/excel")
	// @RequiresPermissions("toExcel")
	public ModelAndView exportExcel() throws Exception{
		ModelAndView mv = new ModelAndView();
		PageData pd = new PageData();
		pd = this.getPageData();
		Map<String,Object> dataMap = new HashMap<String,Object>();
		List<String> titles = new ArrayList<String>();
		titles.add("储罐1液位");	//1
		titles.add("储罐1温度");	//2
		titles.add("储罐2液位");	//3
		titles.add("储罐2温度");	//4
		titles.add("储罐3液位");	//5
		titles.add("储罐3温度");	//6
		titles.add("储罐4液位");	//7
		titles.add("储罐4温度");	//8
		titles.add("储罐5液位");	//9
		titles.add("储罐5温度");	//10
		titles.add("储罐6液位");	//11
		titles.add("储罐6温度");	//12
		titles.add("储罐7液位");	//13
		titles.add("储罐7温度");	//14
		titles.add("储罐8液位");	//15
		titles.add("储罐8温度");	//16
		titles.add("储罐9液位");	//17
		titles.add("储罐9温度");	//18
		dataMap.put("titles", titles);
		pd.put("CORPINFO_ID", Jurisdiction.getCORPINFO_ID());	//企业ID
		List<PageData> varOList = majordangersourcestoragetankService.listAll(pd);
		List<PageData> varList = new ArrayList<PageData>();
		for(int i=0;i<varOList.size();i++){
			PageData vpd = new PageData();
			vpd.put("var1", varOList.get(i).getString("STORAGETANK1_LIQUIDLEVEL"));	    //1
			vpd.put("var2", varOList.get(i).getString("STORAGETANK1_TEMPERATURE"));	    //2
			vpd.put("var3", varOList.get(i).getString("STORAGETANK2_LIQUIDLEVEL"));	    //3
			vpd.put("var4", varOList.get(i).getString("STORAGETANK2_TEMPERATURE"));	    //4
			vpd.put("var5", varOList.get(i).getString("STORAGETANK3_LIQUIDLEVEL"));	    //5
			vpd.put("var6", varOList.get(i).getString("STORAGETANK3_TEMPERATURE"));	    //6
			vpd.put("var7", varOList.get(i).getString("STORAGETANK4_LIQUIDLEVEL"));	    //7
			vpd.put("var8", varOList.get(i).getString("STORAGETANK4_TEMPERATURE"));	    //8
			vpd.put("var9", varOList.get(i).getString("STORAGETANK5_LIQUIDLEVEL"));	    //9
			vpd.put("var10", varOList.get(i).getString("STORAGETANK5_TEMPERATURE"));	    //10
			vpd.put("var11", varOList.get(i).getString("STORAGETANK6_LIQUIDLEVEL"));	    //11
			vpd.put("var12", varOList.get(i).getString("STORAGETANK6_TEMPERATURE"));	    //12
			vpd.put("var13", varOList.get(i).getString("STORAGETANK7_LIQUIDLEVEL"));	    //13
			vpd.put("var14", varOList.get(i).getString("STORAGETANK7_TEMPERATURE"));	    //14
			vpd.put("var15", varOList.get(i).getString("STORAGETANK8_LIQUIDLEVEL"));	    //15
			vpd.put("var16", varOList.get(i).getString("STORAGETANK8_TEMPERATURE"));	    //16
			vpd.put("var17", varOList.get(i).getString("STORAGETANK9_LIQUIDLEVEL"));	    //17
			vpd.put("var18", varOList.get(i).getString("STORAGETANK9_TEMPERATURE"));	    //18
			varList.add(vpd);
		}
		dataMap.put("varList", varList);
		ObjectExcelView erv = new ObjectExcelView();
		mv = new ModelAndView(erv,dataMap);
		return mv;
	}

}
